// ApiExam : Windows API   ϰ ˻غ  ִ ƿƼ
// ۼ : 
//   : 2001.7.2

#include <windows.h>
#include <commctrl.h>
#include <io.h>					// for _access
#include <shlobj.h>
#include "resource.h"
#include "SHReg.h"

// Լ  
BOOL CALLBACK MainDlgProc(HWND hDlg,UINT iMessage,WPARAM wParam,LPARAM lParam);
BOOL CALLBACK SelRootDlgProc(HWND hDlg,UINT iMessage,WPARAM wParam,LPARAM lParam);
BOOL CALLBACK SelComDlgProc(HWND hDlg,UINT iMessage,WPARAM wParam,LPARAM lParam);
void Initialize();
void ViewSrc(int pk);
void Exec();
BOOL BrowseFolder(HWND hWnd, char *szFolder);
void MyGetSpecialFolderPath(HWND hWnd, int nFolder, char *szPath);
void InsertChild(HWND hTree, HTREEITEM pNode,int pid);
void Open();

//  
HINSTANCE g_hInst;
HWND hDlgMain;
HWND hTree, hEdSrc, hEdDesc, hBtnExec, hBtnCopy, hBtnOpen, hBtnSelCom;
char szRoot[MAX_PATH];
char szCompiler[MAX_PATH];
int ComVersion;
int TotalExam;

//   忡  Ʈ Ű
#define KEY "Software\\KanamSoft\\ApiExam\\"

// Ʈ  ü
struct tagPrj {
	int parent;		// θ  pk. Ʈ -1 .
	char *path;		// 丮 ̸
	char *prj;		// Ʈ ̸. 丮  ""
	char *src;		//  ҽ . NULL̸   ƴ
	char *exe;		//   . NONE̸    ̴.
	char *desc;		//  
};

//     
#include "ExamList.h"

// Entry Point
int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance
	,LPSTR lpszCmdParam,int nCmdShow)
{
	int Result, i;
	char szPath[MAX_PATH+100];
	BOOL bNotInstall;
	g_hInst=hInstance;
	InitCommonControls();

	//  ġ Ʈ  Ѵ.  Է¹޴´.
	SHRegReadString(HKEY_CURRENT_USER,KEY"Setting","Root","",szRoot,MAX_PATH);
	if (lstrlen(szRoot)==0) {
		Result=DialogBox(g_hInst, MAKEINTRESOURCE(IDD_DLGSELROOT), HWND_DESKTOP, SelRootDlgProc);
		if (Result == IDCANCEL) {
			MessageBox(NULL," ִ   ʾǷ    ϴ. մϴ.", "˸", MB_OK);
			return 0;
		}
	}

	//   ġǾ ִ ȮѴ. 50  Ʈ Ʒ  ִ ȮѴ.
	for (i=0,bNotInstall=FALSE;i<50;i++) {
		if (arPrj[i].parent == 0) {
			wsprintf(szPath, "%s\\%s",szRoot,arPrj[i].path);
			if (_access(szPath,0) != 0) {
				bNotInstall=TRUE;
				break;
			}
		}
	}

	//  ġǾ    źѴ.
	if (bNotInstall==TRUE) {
		wsprintf(szPath,"%s    ġǾ  ʽϴ.  ٽ ġ ֽʽÿ",szRoot);
		MessageBox(NULL,szPath, "˸", MB_OK);
		SHRegWriteString(HKEY_CURRENT_USER,KEY"Setting","Root","");
		return 0;
	}

	// Ϸ  θ Ѵ.
	SHRegReadString(HKEY_CURRENT_USER,KEY"Setting","Compiler","",szCompiler,MAX_PATH);
	ComVersion=SHRegReadInt(HKEY_CURRENT_USER,KEY"Setting","ComVerion",6);

	//  ȭڸ Ѵ.
	DialogBox(g_hInst, MAKEINTRESOURCE(IDD_DIALOG1), HWND_DESKTOP, MainDlgProc);
	
	return 0;
}

//  ȭ ν
BOOL CALLBACK MainDlgProc(HWND hDlg,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	TVITEMEX TvEx;
	RECT rt;

	switch(iMessage)
	{
	case WM_INITDIALOG:
		hDlgMain = hDlg;
		Initialize();
		return TRUE;
	case WM_SIZE:
		MoveWindow(hTree,0,0,200,HIWORD(lParam),TRUE);
		MoveWindow(hEdDesc,210,0,LOWORD(lParam)-210,80,TRUE);
		MoveWindow(hEdSrc,210,90,LOWORD(lParam)-210,HIWORD(lParam)-140,TRUE);
		MoveWindow(hBtnExec,210,HIWORD(lParam)-40,90,25,TRUE);
		MoveWindow(hBtnCopy,310,HIWORD(lParam)-40,90,25,TRUE);
		MoveWindow(hBtnOpen,410,HIWORD(lParam)-40,90,25,TRUE);
		MoveWindow(hBtnSelCom,510,HIWORD(lParam)-40,110,25,TRUE);
		return TRUE;
	case WM_GETMINMAXINFO:
		((LPMINMAXINFO)lParam)->ptMinTrackSize.x = 500;
		((LPMINMAXINFO)lParam)->ptMinTrackSize.y = 400;
		return 0;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDCANCEL:
			//   ġ  ´.
			GetWindowRect(hDlg, &rt);
			SHRegWriteInt(HKEY_CURRENT_USER,KEY"Position","Left",rt.left);
			SHRegWriteInt(HKEY_CURRENT_USER,KEY"Position","Top",rt.top);
			SHRegWriteInt(HKEY_CURRENT_USER,KEY"Position","Right",rt.right);
			SHRegWriteInt(HKEY_CURRENT_USER,KEY"Position","Bottom",rt.bottom);
			SHRegWriteString(HKEY_CURRENT_USER,KEY"Setting","Root",szRoot);
			SHRegWriteString(HKEY_CURRENT_USER,KEY"Setting","Compiler",szCompiler);
			SHRegWriteInt(HKEY_CURRENT_USER,KEY"Setting","ComVersion",ComVersion);
			EndDialog(hDlg,0);
			return TRUE;
		case IDC_BTNEXEC:
			Exec();
			return TRUE;
		// ҽ ü 
		case IDC_BTNCOPY:
			SendMessage(hEdSrc, EM_SETSEL, 0, -1);
			SendMessage(hEdSrc, WM_COPY,0,0);
			return TRUE;
		case IDC_BTNOPEN:
			Open();
			return TRUE;
		case IDC_BTNSELCOM:
			DialogBox(g_hInst, MAKEINTRESOURCE(IDD_DLGSELCOM), hDlgMain, SelComDlgProc);
			return TRUE;
		}
		return FALSE;
	case WM_NOTIFY:
		LPNMHDR hdr;
		LPNMTREEVIEW ntv;
		hdr=(LPNMHDR)lParam;
		ntv=(LPNMTREEVIEW)lParam;
		if (hdr->hwndFrom == hTree) {
			switch (hdr->code) {
			// õ ׸ ش.
			case TVN_SELCHANGED:
				TvEx.mask=TVIF_PARAM;
				TvEx.hItem=ntv->itemNew.hItem;
				TreeView_GetItem(hTree,&TvEx);
				ViewSrc((int)TvEx.lParam);
				return TRUE;
			}
		}
	}
	return FALSE;
}

//  ġ   ȭ ν
BOOL CALLBACK SelRootDlgProc(HWND hDlg,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	char Path[MAX_PATH];

	switch(iMessage)
	{
	case WM_INITDIALOG:
		SetDlgItemText(hDlg,IDC_STMES,"ó ϼ̽ϴ.    ֽʽÿ");
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam))
		{
		case IDOK:
			GetDlgItemText(hDlg,IDC_EDROOT,szRoot,MAX_PATH);
			EndDialog(hDlg,IDOK);
			return TRUE;
		case IDCANCEL:
			EndDialog(hDlg,IDCANCEL);
			return TRUE;
		case IDC_BTNBR:
			BrowseFolder(hDlg,Path);
			SetDlgItemText(hDlg,IDC_EDROOT,Path);
			return TRUE;
		}
		return FALSE;
	}
	return FALSE;
}

// Ϸ  ȭ ν
BOOL CALLBACK SelComDlgProc(HWND hDlg,UINT iMessage,WPARAM wParam,LPARAM lParam)
{
	OPENFILENAME OFN;
	char lpstrFile[MAX_PATH]="";

	switch(iMessage)
	{
	case WM_INITDIALOG:
		// Ϸ   Ǿ   Ʈ ãش.
		if (lstrlen(szCompiler) == 0) {
			MyGetSpecialFolderPath(NULL,CSIDL_PROGRAM_FILES ,szCompiler);
			lstrcat(szCompiler,"\\Microsoft Visual Studio\\Common\\MSDev98\\Bin\\MSDEV.EXE");
			if (_access(szCompiler,0) != 0) {
				lstrcpy(szCompiler, "");
			}
		}
		SetDlgItemText(hDlg,IDC_EDCOMPATH,szCompiler);
		if (ComVersion == 6) {
			CheckRadioButton(hDlg,IDC_RADIO1,IDC_RADIO2,IDC_RADIO1);
		} else {
			CheckRadioButton(hDlg,IDC_RADIO1,IDC_RADIO2,IDC_RADIO2);
		}
		return TRUE;
	case WM_COMMAND:
		switch (LOWORD(wParam))	{
		case IDOK:
			GetDlgItemText(hDlg,IDC_EDCOMPATH,szCompiler,MAX_PATH);
			if (IsDlgButtonChecked(hDlg,IDC_RADIO1) == TRUE) {
				ComVersion=6;
			} else {
				ComVersion=7;
			}
			EndDialog(hDlg,IDOK);
			return TRUE;
		case IDCANCEL:
			EndDialog(hDlg,IDCANCEL);
			return TRUE;
		case IDC_BTNBR:
			memset(&OFN, 0, sizeof(OPENFILENAME));
			OFN.lStructSize = sizeof(OPENFILENAME);
			OFN.hwndOwner=hDlg;
			OFN.lpstrFilter="\0*.exe\0(*.*)\0*.*\0";
			OFN.lpstrFile=lpstrFile;
			OFN.nMaxFile=256;
			if (GetOpenFileName(&OFN)!=0) {
				SetDlgItemText(hDlg,IDC_EDCOMPATH,OFN.lpstrFile);
			}
			return TRUE;
		}
		return FALSE;
	}
	return FALSE;
}

// ʱȭ Լ
void Initialize()
{
	HICON hIcon;
	int TabStops[]={20};

	// ȭ  Ѵ.
	hIcon=LoadIcon(g_hInst,MAKEINTRESOURCE(IDI_ICON1));
	SendMessage(hDlgMain,WM_SETICON,(WPARAM)ICON_BIG,(LPARAM)hIcon);

	// ڽ Ʈ ڵ ̸  ´.
	hTree=GetDlgItem(hDlgMain,IDC_TVPATH);
	hEdSrc=GetDlgItem(hDlgMain,IDC_EDSRC);
	hEdDesc=GetDlgItem(hDlgMain,IDC_EDDESC);
	hBtnExec=GetDlgItem(hDlgMain,IDC_BTNEXEC);
	hBtnCopy=GetDlgItem(hDlgMain,IDC_BTNCOPY);
	hBtnOpen=GetDlgItem(hDlgMain,IDC_BTNOPEN);
	hBtnSelCom=GetDlgItem(hDlgMain,IDC_BTNSELCOM);

	//   20ȼ ٲ۴. ̰ ʹ    ̴.
	SendMessage(hEdSrc, EM_SETTABSTOPS,1,(LPARAM)TabStops);

	// ̹ Ʈ  Ѵ.
	HIMAGELIST hImgTree=ImageList_LoadBitmap(g_hInst, 
		MAKEINTRESOURCE(IDB_TREEBULLET), 16, 1, RGB(255,255,255));
	::SendMessage(hTree, TVM_SETIMAGELIST, 
		(WPARAM)TVSIL_NORMAL, (LPARAM)hImgTree);

	//   
	TotalExam=sizeof(arPrj)/sizeof(arPrj[0]);

	// Ʈ Ѵ. Ʈ ϴ  ´.
	InsertChild(hTree, 0, -1);
	TreeView_Expand(hTree,TreeView_GetRoot(hTree),TVE_EXPAND);

	//    ġ ̵Ѵ. ִ, ּȭ ´ Ѵ.
	RECT rt;
	rt.left=SHRegReadInt(HKEY_CURRENT_USER,KEY"Position","Left",100);
	rt.top=SHRegReadInt(HKEY_CURRENT_USER,KEY"Position","Top",100);
	rt.right=SHRegReadInt(HKEY_CURRENT_USER,KEY"Position","Right",800);
	rt.bottom=SHRegReadInt(HKEY_CURRENT_USER,KEY"Position","Bottom",600);
	MoveWindow(hDlgMain, rt.left, rt.top, rt.right-rt.left,rt.bottom-rt.top, TRUE);
}

// pk   θ Ѵ.
void GetFullPath(int pk, char *FullPath)
{
	char Path[MAX_PATH];
	char szTmp[MAX_PATH];
	int parent=0;

	// ϴ ڽ κ Ѵ.
	lstrcpy(Path, arPrj[pk].path);

	// θ 带 Ž ö󰡸 θ θ Ѵ.
	parent=pk;
	for (;;) {
		parent=arPrj[parent].parent;
		if (parent == 0) 
			break;
		lstrcpy(szTmp, Path);
		wsprintf(Path, "%s\\%s", arPrj[parent].path, szTmp);
	}

	// Ʈ θ Ͽ  θ .
	lstrcpy(szTmp, Path);
	wsprintf(FullPath, "%s\\%s", szRoot, szTmp);
}

// pk ҽ ش.
void ViewSrc(int pk)
{
	char Path[MAX_PATH];
	char szTmp[MAX_PATH];

	// ϴ  Ѵ.
	SetWindowText(hEdDesc, arPrj[pk].desc);

	// ҽ  δ Ѵ.
	if (arPrj[pk].src == NULL) {
		return;
	}

	// ҽ   θ Ѵ.
	GetFullPath(pk,szTmp);
	wsprintf(Path, "%s\\%s", szTmp, arPrj[pk].src);

	//  о Ʈ Ʈѿ ش.
	HANDLE hFile;
	char buf[32767];
	DWORD dwRead;
	hFile=CreateFile(Path,GENERIC_READ,0,NULL,
		OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if (hFile==INVALID_HANDLE_VALUE) {
		wsprintf(szTmp,"%s ҽ  ϴ.   ġǾ ִ"
			" Ȯ ֽʽÿ.",Path);
		MessageBox(hDlgMain,szTmp,"˸",MB_OK);
		return;
	}
	ReadFile(hFile,buf,32767,&dwRead,NULL);
	buf[dwRead]=0;
	SetWindowText(hEdSrc,buf);
	CloseHandle(hFile);
}

//  Ѵ.
void Exec()
{
	HTREEITEM hNow;
	TVITEMEX TvEx;
	int pk;
	char Path[MAX_PATH];
	char szTmp[MAX_PATH];
	char szWork[MAX_PATH];

	//  õ ׸ pk Ѵ.
	hNow=TreeView_GetSelection(hTree);
	if (hNow==NULL)
		return;

	TvEx.mask=TVIF_PARAM;
	TvEx.hItem=hNow;
	TreeView_GetItem(hTree,&TvEx);
	pk=TvEx.lParam;
	
	//    δ Ѵ.
	if (arPrj[pk].exe == NULL) {
		return;
	}

	//    Ʈ  ȳ
	if (lstrcmpi(arPrj[pk].exe,"NONE")==0) {
		MessageBox(hDlgMain," Ʈ  ų    ϴ.","˸",MB_OK);
		return;
	}

	//    θ Ѵ. Release  ִ  Ѵ.
	GetFullPath(pk,szTmp);
	wsprintf(szWork,"%s\\Release",szTmp);
	wsprintf(Path, "%s\\%s", szWork, arPrj[pk].exe);

	//   ִ ȮѴ.
	if (_access(Path,0) != 0) {
		wsprintf(szTmp,"%s   ϴ.   ġǾ ִ"
			" Ȯ ֽʽÿ.",Path);
		MessageBox(hDlgMain,szTmp,"˸",MB_OK);
		return;
	}

	//  Ѵ.  ΰ  丮 Ǿ Ѵ.
	STARTUPINFO si={0,};
	PROCESS_INFORMATION pi;
	CreateProcess(NULL, Path,NULL,NULL,FALSE,0,NULL,szWork,&si,&pi);
}

// Ʈ 
void Open()
{
	HTREEITEM hNow;
	TVITEMEX TvEx;
	int pk;
	char szTmp[MAX_PATH];
	char szProject[MAX_PATH];
	char szWork[MAX_PATH*2];
	char ext[4];

	if (lstrlen(szCompiler) == 0) {
		MessageBox(hDlgMain,"Ʈ   ִ Ϸ   ֽʽÿ.","˸",MB_OK);
		return;
	}

	//  õ ׸ pk Ѵ.
	hNow=TreeView_GetSelection(hTree);
	if (hNow==NULL)
		return;

	TvEx.mask=TVIF_PARAM;
	TvEx.hItem=hNow;
	TreeView_GetItem(hTree,&TvEx);
	pk=TvEx.lParam;
	
	// ҽ   δ Ѵ.
	if (arPrj[pk].src == NULL) {
		return;
	}

	// Ʈ  θ Ѵ. .DSW(Ǵ SLN) Ѵ.
	if (ComVersion == 6) {
		lstrcpy(ext,"dsw");
	} else {
		lstrcpy(ext,"sln");
	}
	GetFullPath(pk,szTmp);

	// Ʈ  Ǿ   丮 Ʈ ȴ.
	if (lstrlen(arPrj[pk].prj) == 0) {
		wsprintf(szProject,"%s\\%s.%s",szTmp,arPrj[pk].path,ext);
	} else {
		wsprintf(szProject,"%s\\%s.%s",szTmp,arPrj[pk].prj,ext);
	}

	// Ϸ Ѵ. Ʈ    Ƿ ǥ ʿϴ.
	wsprintf(szWork,"%s \"%s\"",szCompiler, szProject);
	STARTUPINFO si={0,};
	PROCESS_INFORMATION pi;
	CreateProcess(NULL, szWork,NULL,NULL,FALSE,0,NULL,NULL,&si,&pi);

}

// Parent  ϵ带  ã Ʈ ߰Ѵ.  ϵ忡 ؼ 
// Լ  ȣν  Ʈ  ԷѴ. 
// pNode:θ . 0̸ Ʈ
// pid:θ ε ȣ(iRecord)
void InsertChild(HWND hTree, HTREEITEM pNode,int pid)
{
	TVINSERTSTRUCT TI;
	HTREEITEM Node;
	int i;

	// Ʈ ߰Ѵ.
	for (i=0;i<TotalExam;i++) {
		if (arPrj[i].parent != pid)
			continue;
		TI.hParent=pNode;
		TI.hInsertAfter=TVI_LAST;
		TI.item.mask=TVIF_TEXT | TVIF_PARAM | TVIF_IMAGE | TVIF_SELECTEDIMAGE;
		if (arPrj[i].src==NULL) {
			TI.item.iImage=0;
			TI.item.iSelectedImage=1;
		} else {
			TI.item.iImage=2;
			TI.item.iSelectedImage=3;
		}

		// lParam 迭 ÷ڸ ִµ  ÷ڰ pk ȴ.
		TI.item.pszText=arPrj[i].path;
		TI.item.lParam=(LPARAM)i;
		Node=TreeView_InsertItem(hTree, &TI);

		// ϵ ϵ带 ä ִ´.
		InsertChild(hTree,Node,i);
	}
}

//  Ͽ szFolder ۿ  ش.
BOOL BrowseFolder(HWND hWnd, char *szFolder)
{
	LPMALLOC ShellMalloc;
	LPITEMIDLIST idBrowse;
	BROWSEINFO BrowseInfo;
	char szDisplayName[MAX_PATH];

	if (SHGetMalloc(&ShellMalloc) != NOERROR) {
		return FALSE;
	}

	BrowseInfo.hwndOwner = hWnd;
	BrowseInfo.pidlRoot = NULL;
	BrowseInfo.pszDisplayName = szDisplayName;
	BrowseInfo.lpszTitle = "Windows API   ġ  Ͻʽÿ" ;
	BrowseInfo.ulFlags = BIF_DONTGOBELOWDOMAIN;
	BrowseInfo.lpfn = NULL;
	BrowseInfo.lParam = 0;
						
	idBrowse = SHBrowseForFolder(&BrowseInfo);

	if (idBrowse == NULL) {
		return FALSE;
	}
	SHGetPathFromIDList(idBrowse, szFolder);
	ShellMalloc->Free(idBrowse);
	ShellMalloc->Release();
	return TRUE;
}

// Ư  θ ˻Ѵ.
void MyGetSpecialFolderPath(HWND hWnd, int nFolder, char *szPath)
{
	LPITEMIDLIST pidl;
	LPMALLOC pMalloc;

	SHGetSpecialFolderLocation(hWnd,nFolder,&pidl);
	SHGetPathFromIDList(pidl, szPath);
	SHGetMalloc(&pMalloc);
	pMalloc->Free(pidl);
	pMalloc->Release();
}